unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Math,
  TAGraph, TATools, TASeries, TATransformations, Types, TAChartUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart: TChart;
    ChartToolset: TChartToolset;
    ChartToolsetPanDragTool1: TPanDragTool;
    ChartToolsetZoomDragTool1: TZoomDragTool;
    procedure ChartToolsetZoomDragTool1BeforeMouseDown(ATool: TChartTool; APoint: TPoint);
    procedure ChartToolsetCalculateNewExtent(ATool: TChartTool; var ANewExtent: TDoubleRect);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  LSeries: TLineSeries;
  i: Integer;
begin
  LSeries := TLineSeries.Create(Chart);
  LSeries.AddXY(0, 50);
  for i := 1 to 100 do
    LSeries.AddXY(i, LSeries.GetYValue(i - 1) + Random(9) - 4);
  Chart.AddSeries(LSeries);
end;

procedure TForm1.ChartToolsetZoomDragTool1BeforeMouseDown(ATool: TChartTool; APoint: TPoint);
begin
  Chart.SetFocus;
end;

procedure TForm1.ChartToolsetCalculateNewExtent(ATool: TChartTool; var ANewExtent: TDoubleRect);
var
  LSeries: TLineSeries;
  YMin, YMax: Double;
begin
  LSeries := TLineSeries(Chart.Series[0]);
  YMin := 1000;
  YMax := -1000;
  LSeries.FindYRange(ANewExtent.a.X, ANewExtent.b.X, YMin, YMax);
  ANewExtent.a.Y := YMin;
  ANewExtent.b.Y := YMax;
end;

end.

